#!/usr/bin/python3
import socket
import sys

HOST = "127.0.0.1"  # The server's hostname or IP address
PORT = 52500        # the port used by the Python server

with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
    try:                                # пробуем присоединиться
        s.connect((HOST, PORT))
    except ConnectionRefusedError:
        print("no server available")
        quit()
    while True:
        sys.stdout.write("> " )
        sys.stdout.flush()
        try:
            str = sys.stdin.readline()
        except KeyboardInterrupt:       # ^C - завершение работы
            print("\r")
            break 
        if str == '':                   # ^D - завершение работы
            sys.stdout.write('\r')
            break
        if "\n" == str:                 # Enter - завершение работы
            break
        s.sendall(bytes(str, "UTF-8"))
        data = s.recv(1024)
        print(" ", data.decode("UTF-8"), end='')


