#!/usr/bin/python3
import socket

HOST = "127.0.0.1"             # loopback interface address (localhost)
PORT = 52500                   # port to listen with Python

with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
    try:
        s.bind((HOST, PORT)) 
    except OSError:
        print("address already in use")
        quit()    
    s.listen()
    while True:
        print('waiting on port', PORT)
        try:
            conn, addr = s.accept()
        except KeyboardInterrupt:
            print()
            quit()
        with conn:
            while True:
                data = conn.recv(1024)
                if not data:       # клиент закрыл сокет
                    break
                conn.sendall(data)
        conn.close()        
