use std::io;
use std::io::prelude::*;
use std::net::TcpStream;

fn main() -> std::io::Result<()> {
    let mut stream = match TcpStream::connect("127.0.0.1:53500") {    
        Ok(stream) => stream,
        _ => {
            println!("no server available");
            return Ok(());
        },
    };
    loop {
        print!("> ");
        io::stdout().flush()?;
        let mut req = String::new();
        io::stdin()
            .read_line(&mut req)
            .expect("ошибка ввода пользователя");
        if req.is_empty() {         // ^D - завершение работы
            println!("");
            break;
        }
        if req.len() == 1 {         // Enter - завершение работы
            break;
        }

        match stream.write(&req.as_bytes()) {
            Ok(..) => (),
            Err(e) => println!("Error: {}", e)
        }
        let mut buffer = [0; 120];     // буфер чтения
        match stream.read(&mut buffer) {
            Ok(..) => (),
            Err(e) => println!("Error: {}", e),
        }
        let rep = String::from_utf8_lossy(&buffer[..]);
        print!("{}", rep);
    }
    Ok(())
}
