use std::io::{Read, Write};
use std::net::{TcpListener, TcpStream};

fn handle_client(mut stream: TcpStream) {
    loop {
	let mut buffer = [0; 120];
        match stream.read(&mut buffer) {
            Err(_)  => {   //клиент закрыл сокет
                return;
            }
            _ => (),	    
        }
	match stream.write(&mut buffer) {
	    Err(_)  => {   //клиент закрыл сокет
		return;
	    }
            _ => (),	    
	} 
    }
}

fn main() {
    const PORT : &str = "53500"; 
    let listener = match 
	TcpListener::bind("127.0.0.1:".to_string() + PORT) {
        Ok(listener) => listener,
        Err(_) => {
            println!("серверный порт занят");
            return;
        }
    };
    println!("waiting on port {}", PORT);
    for stream in listener.incoming() {
	println!("waiting on port {}", PORT); // новый клиент
	match stream {
	    Ok(stream) => {
		std::thread::spawn(move || handle_client(stream));
	    }
	    Err(e) => {
    		eprintln!("ошибка соединения: {}", e);
	    }
	}
    }
}
